#include <stdio.h>
#include <math.h>
#include <stdlib.h>

double pierwiastek1 (double a, double b, double c);
double pierwiastek2 (double a, double b, double c);

void main()
{
    double a,b,c,
		   x,y,
		   xp,xk,dx,
		   del,x1,x2;
	int N; // zmienna pomocna do okrelenia rozmiaru dynamicznej tablicy
	double *tabXD; double *tabYD; // deklaracja wskaznikow / pierwszych elementow tablic - bez tego nie skompiluje
	tabXD = (double*) malloc ( N * sizeof (double) ); // dynamiczna tablica X - deklaracja
	tabYD = (double*) malloc ( N * sizeof (double) ); // dynamiczna tablica Y - deklaracja    
	printf("Program do obliczania delty\nPodaj a,b i c:\n");
    scanf("%lf %lf %lf", &a, &b, &c);
    printf("\na = %6.2lf b = %6.2lf c = %6.2lf\n", a, b, c);
    del=b*b-4*a*c;
    if(del > 0.) // INSTRUKCJA WARUNKOWA IF (gdy delta > 0.)
    {
        x1=pierwiastek1(a,b,c);  // OBLICZANIE PIERWIASTKA 1 za pomoc funkcji pierwiastek1
        x2=pierwiastek2(a,b,c); // OBLICZANIE PIERWIASTKA 2 za pomoc funkcji pierwiastek2
        printf("\nX1=%10.4lf   X2=%10.4lf\n", x1, x2);
    }
    else if (del==0.) // Gdy delta = 0.
	{
        x1=pierwiastek1(a,b,c);  // OBLICZANIE PIERWIASTKA 1 za pomoc funkcji pierwiastek1 (tylko jednego)
		printf("\nX1=%10.4lf", x1);
	}
	else if (del < 0.) // Gdy delta < 0.
	{
        printf("\nBrak pierwiastkow rzeczywistych. Podaj przedzial (poczatek i jego koniec) oraz krok tablicowania:\n");
        scanf("%lf %lf %lf", &xp, &xk, &dx); // odczyt danych potrzebnych do tablicowania
        printf("\n");
		N =(xk-xp)/dx +1; // okreslenie rozmiaru tablicy na podstawie podanych krokow - 5 kawalkow to 6 punktow!! (UWAGA - konwersja double to int !!!)
		printf("\nN = %d\n", N);
        x=xp; // podstawienie wartoci ze zmiennej xp (poczatek tablicowania) do zmiennej x
		for (int i=0; i<N; i++) // tablicowa ptla FOR - od 0 elementu tablicy do 
		{
			if ( i == 0) // warunek na poprawne inicjalizowanie
			{	
				tabXD[i] = xp;
				tabYD[i] = a*tabXD[i]*tabXD[i] + b*tabXD[i] + c;
				printf ( "x = %10.2lf  y = %10.2lf\n", tabXD[i], tabYD[i] );
			}
			else
			{
				tabXD[i]= tabXD[i-1] + dx;
				tabYD[i] = a*tabXD[i]*tabXD[i] + b*tabXD[i] + c;
				printf ( "x = %10.2lf  y = %10.2lf\n", tabXD[i], tabYD[i] );
			}
		}
	}
	free (tabXD); // zwolnienie pamici tablicy XD, inaczej wyciek pamieci
	free (tabYD); // zwolnienie pamici tablicy YD, inaczej wyciek pamieci
	getchar(); getchar();
}

double pierwiastek1 (double a, double b, double c)
{
    double pierwiastek1,del;
    del = pow(b,2)-4*a*c;
    printf("\nDelta = %6.2f\n",del);
    if(del>=0.) pierwiastek1=(-b-sqrt(del)/(2*a));
    else printf("\nBrak pierwiastkow rzeczywistych!");
    return pierwiastek1;
}

double pierwiastek2 (double a, double b, double c)
{
    double pierwiastek2,delta;
    delta = pow(b,2)-4*a*c;
    if(delta>=0.) pierwiastek2=(-b+sqrt(delta)/(2*a));
    else printf("\nBrak pierwiastkow rzeczywistych!");
    return pierwiastek2;
}
